//-----------------------------------------------------------------------------
// name: JackAtherton_HW1_Milestone1.ck
// desc: printer music ("done" but only from a "this assignment
//                       needs to be turned in now" point of view)
// title: "the print queue is full when you run out of time"
//
// author: Jack Atherton (lja@ccrma.stanford.edu)
// date: winter 2019
//-----------------------------------------------------------------------------


fun void PlaySndFile( string filename, dur inHowLong, dur negativeOffset, float gain, float rate, UGen out )
{
    SndBuf buf => out;
    me.dir() + filename => buf.read;
    0 => buf.gain;
    
    inHowLong - negativeOffset => now;
    
    0 => buf.pos;
    gain => buf.gain;
    rate => buf.rate;
    
    buf.length() / buf.rate() => now;
    buf =< out;
}

NRev revL => dac.left;
NRev revR => dac.right;
Gain centered => revL;
centered => revR;
0.015 => revL.mix;
0.015 => revR.mix;
false => int turnOffSlowPrinter;
fun void Opener()
{
    spork ~ PlaySndFile( "button1.wav", 0::second, 0::second, 1, 1, centered );
    spork ~ PlaySndFile( "tray1.wav", 0.5::second, 0::ms, 1, 1, centered );
    spork ~ PlaySndFile( "paper1.wav", 1.3::second, 0::ms, 1, 1, centered );
    4::second => now;
}

fun void Warmup()
{
    Pan2 leftish, rightish;
    leftish.left => revL;
    leftish.right => revR;
    rightish.left => revL;
    rightish.right => revR;
    -0.6 => leftish.pan;
    0.6 => rightish.pan;
    
    spork ~ PlaySndFile( "printer_startup1.wav", 0::second, 0::second, 1, 1, centered );
    spork ~ PlaySndFile( "printer_agitated1.wav", 1.6::second, 0::second, 1, 1, leftish );
    spork ~ PlaySndFile( "printer_agitated2.wav", 3::second, 0::second, 1, 1, rightish );
    6::second => now;
    
    spork ~ PlaySndFile( "printer_scan3.wav", 0::second, 0::second, 1, 1, rightish );
    spork ~ PlaySndFile( "printer_scan2.wav", 5::second, 0::second, 1, 1, leftish );
    9.5::second => now;
}

fun void ScanCrazy() 
{
    Pan2 panner;
    panner.left => revL;
    panner.right => revR;
    0 => panner.pan;
    SndBuf buf => panner;
    me.dir() + "printer_scan1.wav" => buf.read;
    
    1.5::second => now;
    
    // do a thing 7 times
    float rateRange;
    repeat( 7 )
    {
        
        // choose a region and repeat it 2-6 times
        Math.random2( 1000, 8000 ) => int pos;
        Math.random2f( 0.1, 0.3 )::second => dur len;
        Math.random2( 2, 6 ) => int times;
        
        repeat( times )
        {
            // rate
            Math.random2f( 1 - rateRange, 1 + rateRange ) => buf.rate;
            
            // panning
            Math.random2f( -0.6, 0.6 ) => panner.pan;
        
            
            pos => buf.pos;
            len => now;
        }
        
        0.06 +=> rateRange;
    }
    
    (buf.samples() - buf.pos())::samp / buf.rate() => now;
    
    1.5::second => now;
}

fun void Gasp()
{
    SndBuf buf => centered;
    me.dir() + "printer_gasp.wav" => buf.read;
    0.25::second => now;
    for( int i; i < 100; i++ )
    {
        buf.rate() * 0.97 => buf.rate;
        10::ms => now;
    }
    0.7::second => now;
}

1.525::second => dur loopLength;
1 => float printingBufRates;

fun void Metro()
{
    Impulse i => centered;
    while( true )
    {
        0.8 => i.next;
        0.25::loopLength => now;
    }
}
//spork ~ Metro();

fun void HumLoop()
{
    while( !turnOffSlowPrinter )
    {
        // awful loop unrolling to get it to stop earlier
        me.yield();
        spork ~ PlaySndFile( "printer_hum_only.wav", 0::second, 0::second, 1.1, printingBufRates, centered );
        
        1::loopLength - 0.38::second / printingBufRates => now;
        if( !turnOffSlowPrinter) spork ~ PlaySndFile( "printer_hum_full.wav", 0::second, 0::second, 1.1, printingBufRates, centered );
        0.38::second / printingBufRates => now;
        2::loopLength => now;
         
    }
}



fun void GrumbleLoop()
{
    Pan2 leftish, rightish;
    leftish.left => revL;
    leftish.right => revR;
    rightish.left => revL;
    rightish.right => revR;
    -0.4 => leftish.pan;
    0.4 => rightish.pan;
    1.4 => leftish.gain => rightish.gain;
    
    while( !turnOffSlowPrinter )
    {
        spork ~ PlaySndFile( "printer_grumble1.wav", 0::second, 0::second, 2, printingBufRates, leftish );
        spork ~ PlaySndFile( "printer_grumble6.wav", 0.5::loopLength, 0::second, 2, printingBufRates, rightish );
        
        spork ~ PlaySndFile( "printer_grumble2.wav", 1::loopLength, -1 * 0.1::second / printingBufRates, 2, printingBufRates, rightish );
        spork ~ PlaySndFile( "printer_grumble5.wav", 1.5::loopLength, 0::second, 2, printingBufRates, leftish );
        1::loopLength => now;
        
        spork ~ PlaySndFile( "printer_grumble3.wav", 1::loopLength, 0.05::second / printingBufRates, 2, printingBufRates, leftish );
        spork ~ PlaySndFile( "printer_grumble4.wav", 1.5::loopLength, 0.43::second / printingBufRates, 2, printingBufRates, rightish );
        1::loopLength => now;
        1::loopLength => now;
        
    }
}

Gain printingLoopGain => PitShift printingPitShift1 => Gain halfIt => centered;
printingLoopGain => PitShift printingPitShift2 => halfIt;
0.5 => halfIt.gain;
fun void PrintingLoop()
{
    while( !turnOffSlowPrinter )
    {
        int which;
        if( Math.random2f( 0, 1 ) < 0.1 )
        {
            // play a blank one
            // forward
            0 => which;
            // reversed
            if( maybe ) 5 => which;
        }
        else
        {
            // play a fun one
            // forward
            Math.random2( 1, 4 ) => which;
            // reversed
            if( maybe ) Math.random2( 6, 9 ) => which;
        }
        
        spork ~ PlaySndFile( "printing_" + which + ".wav", 0::second, 0::second, 1, printingBufRates, printingLoopGain );
        1::loopLength => now;
    }
}


//-----------------------------------------------------------------------------
// name: ks-chord.ck
// desc: karplus strong comb filter bank
//
// authors: Madeline Huberth (mhuberth@ccrma.stanford.edu)
//          Ge Wang (ge@ccrma.stanford.edu)
// date: summer 2014
//       Stanford Center @ Peking University
//-----------------------------------------------------------------------------

// single voice Karplus Strong chubgraph
class KS extends Chubgraph
{
    // sample rate
    second / samp => float SRATE;
    
    // ugens!
    DelayA delay;
    OneZero lowpass;
    
    // noise, only for internal use
    Noise n => delay;
    // silence so it doesn't play
    0 => n.gain;
    
    // the feedback
    inlet => delay => lowpass => delay => outlet;
    // max delay
    1::second => delay.max;
    // set lowpass
    -1 => lowpass.zero;
    // set feedback attenuation
    .9 => lowpass.gain;
    
    // mostly for testing
    fun void play( float pitch, dur T )
    {
        tune( pitch ) => float length;
        // turn on noise
        1 => n.gain;
        // fill delay with length samples
        length::samp => now;
        // silence
        0 => n.gain;
        // let it play
        T-length::samp => now;
    }
    
    // tune the fundamental resonance
    fun float tune( float pitch )
    {
        // computes further pitch tuning for higher pitches
        pitch - 43 => float diff;
        0 => float adjust;
        if( diff > 0 ) diff * .0125 => adjust;
        // compute length
        computeDelay( Std.mtof(pitch+adjust) ) => float length;
        // set the delay
        length::samp => delay.delay;
        //return
        return length;
    }
    
    // set feedback attenuation
    fun float feedback( float att )
    {
        // sanity check
        if( att >= 1 || att < 0 )
        {
            <<< "set feedback value between 0 and 1 (non-inclusive)" >>>;
            return lowpass.gain();
        }
        
        // set it        
        att => lowpass.gain;
        // return
        return att;
    }
    
    // compute delay from frequency
    fun float computeDelay( float freq )
    {
        // compute delay length from srate and desired freq
        return SRATE / freq;
    }
}


// chord class for KS
class KSChord extends Chubgraph
{
    // array of KS objects    
    KS chordArray[4];
    
    // connect to inlet and outlet of chubgraph
    for( int i; i < chordArray.size(); i++ ) {
        inlet => chordArray[i] => outlet;
    }
    
    // set feedback    
    fun float feedback( float att )
    {
        // sanith check
        if( att >= 1 || att < 0 )
        {
            <<< "set feedback value between 0 and 1 (non-inclusive)" >>>;
            return att;
        }
        
        // set feedback on each element
        for( int i; i < chordArray.size(); i++ )
        {
            att => chordArray[i].feedback;
        }
        
        return att;
    }
    
    // tune objects
    fun float tune( float pitches[] )
    {
        for( int i; i < pitches.size(); i++ )
        {
            pitches[i] => chordArray[i].tune;
        }
    }
}

// ============= we now return to your regular programming ====== // 


fun void ChangeReverbMix( NRev reverb, float start, float finish, dur len )
{
    start => reverb.mix;
    10::ms => dur delta;
    (len / delta) $ int => int numSteps;
    (finish - start) / numSteps => float stepSize;
    
    for( int i; i < numSteps; i++ )
    {
        start + stepSize * i => reverb.mix;
        delta => now;
    }
    finish => reverb.mix;
    
}

fun void ChangeKSChordFeedback( KSChord chord, float start, float finish, dur len )
{
    start => chord.feedback;
    10::ms => dur delta;
    (len / delta) $ int => int numSteps;
    (finish - start) / numSteps => float stepSize;
    
    for( int i; i < numSteps; i++ )
    {
        start + stepSize * i => chord.feedback;
        delta => now;
    }
    finish => chord.feedback;
}

fun void ChangePan( Pan2 panner, float start, float finish, dur len )
{
    start => panner.pan;
    10::ms => dur delta;
    (len / delta) $ int => int numSteps;
    (finish - start) / numSteps => float stepSize;
    
    for( int i; i < numSteps; i++ )
    {
        start + stepSize * i => panner.pan;
        delta => now;
    }
    finish => panner.pan;
}


fun void ChangeGain( UGen gain, float start, float finish, dur len )
{
    start => gain.gain;
    10::ms => dur delta;
    (len / delta) $ int => int numSteps;
    (finish - start) / numSteps => float stepSize;
    
    for( int i; i < numSteps; i++ )
    {
        start + stepSize * i => gain.gain;
        delta => now;
    }
    finish => gain.gain;
}

fun void ChangeKSFeedback( KS note, float start, float finish, dur len )
{
    start => note.feedback;
    10::ms => dur delta;
    (len / delta) $ int => int numSteps;
    (finish - start) / numSteps => float stepSize;
    
    for( int i; i < numSteps; i++ )
    {
        start + stepSize * i => note.feedback;
        delta => now;
    }
    finish => note.feedback;
}


fun void ChangeLPFCutoff( LPF lpf, float start, float finish, dur len )
{
    start => lpf.freq;
    10::ms => dur delta;
    (len / delta) $ int => int numSteps;
    (finish - start) / numSteps => float stepSize;
    
    for( int i; i < numSteps; i++ )
    {
        start + stepSize * i => lpf.freq;
        delta => now;
    }
    finish => lpf.freq;
}


fun void PlayButtonChords()
{
    // predelay
    loopLength - 0.34 / 4 * 1.525::second => now;
    
    Pan2 panner;
    panner.left => revL;
    panner.right => revR;
    

    SndBuf buf => NRev ampRev => Gain g => NRev preRev => panner;
    // tunable parameter
    0.2 => preRev.mix;
    spork ~ ChangeReverbMix( preRev, 0.0, 0.25, 30::second );
    
    0.4 => buf.gain;
    KSChord chord => g;
    
    0.03 => ampRev.mix;
    me.dir() + "button3.wav" => buf.read;
    0.4::second => dur holdTime;
    

    0.3 => float chordMinFeedback; // todo: maybe back to 0.4 later
    0.85 => float goalChordMaxFeedback; // todo: back to 0.9 or lower
    chord.feedback(chordMinFeedback);
    0.55 => float currentChordMaxFeedback;
    0.1 => float slewChordMaxFeedback;
    
    2 => int x; // offset
    // tune
//    chord.tune( 60+x, 64+x, 67+x, 70+x );
    //chord.tune( 63+x, 70+x, 72+x, 77+x );
    
    [
     [60.+x, 64+x, 67+x, 71+x],
     [59.+x, 62+x, 66+x, 69+x],
     [57.+x, 60+x, 64+x, 67+x]
    ] @=> float chords[][];
    
    0 => float prevPan;
    
    [-0.5, 0, 0.5] @=> float pans[];
    
    while( !turnOffSlowPrinter ) 
    {
        Math.random2( 0, chords.size() - 1 ) => int which;
        chord.tune( chords[which] );          
        
        0 => buf.pos;
        100::ms => now;
        ampRev =< g;
        ampRev => chord;
        spork ~ ChangeReverbMix( ampRev, 0.03, 0.5, 300::ms );
        
        00::ms => now;
        spork ~ ChangeKSChordFeedback( chord, chordMinFeedback, currentChordMaxFeedback, 200::ms );
        
        //Math.random2f( -0.7, 0.7 ) => float nextPan;
        pans[which] => float nextPan;
        spork ~ ChangePan( panner, prevPan, nextPan, 50::ms );
        nextPan => prevPan;
        
        
        holdTime => now;
        spork ~ ChangeKSChordFeedback( chord, currentChordMaxFeedback, chordMinFeedback, 30::ms );
        spork ~ ChangeReverbMix( ampRev, 0.5, 0.03, 60::ms );
        
        // interp
        slewChordMaxFeedback * ( goalChordMaxFeedback - currentChordMaxFeedback ) +=> currentChordMaxFeedback;
        
        0.25::loopLength => dur waitTime;
        if( maybe ) 
        {
            0.5::loopLength => waitTime;
            if( maybe )
            {
                1::loopLength => waitTime;
            }
        }
        waitTime - holdTime - 0::ms - 100::ms => now;
                
        ampRev =< chord;
        ampRev => g;
    }
}

fun void EnterIntoSpookyRealm()
{
    // =================
    
    // arpeggiate up
    // alternate between major 64 chord and minor 64 chord
    
    [[0, 5, 9], [0, 5, 8]] @=> int chords[][];
    
    // increment base a few each time
    34 => int base;
    
    SndBuf buf => KS note => Pan2 panner;
    panner.left => revL;
    panner.right => revR;
    me.dir() + "printer_pop3.wav" => buf.read;
    4 => buf.gain;
    
    note.feedback( 0.9 );
    
    spork ~ ChangeReverbMix( revL, 0.015, 0.4, 4::loopLength );
    spork ~ ChangeReverbMix( revR, 0.015, 0.4, 4::loopLength );
    spork ~ ChangeGain( buf, 0.25, 1.6, 4::loopLength );
    spork ~ ChangeGain( printingLoopGain, 1, 0.1, 4::loopLength );
    
    repeat( 16 )
    {
        maybe => int which;
        
        0 => buf.pos;
        Math.random2f( -0.7, 0.7 ) => panner.pan;
        base + chords[which][0] => note.tune;
        loopLength / 24 => now;
        
        0 => buf.pos;
        Math.random2f( -0.7, 0.7 ) => panner.pan;
        base + chords[which][1] => note.tune;    
        loopLength / 24 => now;
        
        0 => buf.pos;
        Math.random2f( -0.4, 0.4 ) => panner.pan;
        base + chords[which][2] => note.tune;    
        loopLength / 6 => now;
        
        Math.random2( 2, 5 ) +=> base;
        
    }
    loopLength => now;
    
    ContinueEnteringIntoSpookyRealm();
}

fun void ContinueEnteringIntoSpookyRealm()
{
    SndBuf buf => KS pitch1 => LPF lpf => dac;
    buf => KS pitch2 => lpf => dac;
    me.dir() + "printer_pop2.wav" => buf.read;
    0.5 => buf.gain;
    
    
    81 => int note1;
    -8 => int m6Interval;
    note1 + m6Interval => int note2;
    
    0.9 => pitch1.feedback => pitch2.feedback;
    
    spork ~ ChangeKSFeedback( pitch1, 0.8, 0.9, 2::loopLength );
    spork ~ ChangeKSFeedback( pitch2, 0.8, 0.9, 2::loopLength );
    spork ~ ChangeLPFCutoff( lpf, 100, 10000, 2::loopLength );
    
    for( int i; i < 25; i++ )
    {
        0 => buf.pos;
        
        note1 => pitch1.tune;
        note2 => pitch2.tune;
        
        note1--;
        note2--;
        
        // return to normal
        if( i == 24 )
        {
            0.015 => revL.mix;
            0.015 => revR.mix;
            1 => printingLoopGain.gain;
        }
        
        loopLength / 12 => now;
        
    }
    
    0.1 => buf.rate;
    
    10::second => now;
}

fun void LFOPitShift()
{
    SinOsc s1 => blackhole;
    SinOsc s2 => blackhole;
    0.1 => s1.freq;
    0.13 => s2.freq;
    while( true )
    {
        s1.last() / 2 + 1 => printingPitShift1.shift;
        s2.last() / 3 + 1 => printingPitShift2.shift;
        10::ms => now;
    }
}


loopLength => dur origLoopLength;
fun void DecreaseLoopLength()
{
    for( int i; i < 1000; i++ ) 
    {
        0.35 / 1000 -=> printingBufRates;
        origLoopLength / printingBufRates => loopLength;
        10::ms => now;
    }
}




fun void PlayIntro()
{
    Opener();
    Warmup();
    ScanCrazy();
    Gasp();
}
PlayIntro();


fun void PlayMidsection()
{
    spork ~ PrintingLoop();
    4::loopLength => now;
    spork ~ GrumbleLoop();
    6::loopLength => now;
    spork ~ HumLoop();

    loopLength / 12 => dur preLaunchSpooky;
    8::loopLength - preLaunchSpooky => now;
    spork ~ EnterIntoSpookyRealm();
    preLaunchSpooky => now;
    

    // anticipate change (bug fix / hacky workaround)  
    7::loopLength - loopLength / 36 => now;
    0.5 => printingBufRates;
    origLoopLength / printingBufRates => loopLength;
    loopLength / 36 => now;
    
    spork ~ PlayButtonChords();
    spork ~ LFOPitShift();
    
    6::loopLength => now;
    6::loopLength => now;
    
    

    DecreaseLoopLength();
    1::second => now;
    true => turnOffSlowPrinter;
    
    6::second => now;
}
PlayMidsection();

fun void PlayEnd()
{
    0.01 => revL.mix;
    0.01 => revR.mix;
    PlaySndFile( "tray1.wav", 0::second, 0::second, 1, 1, centered );
    0.5::second => now;
    PlaySndFile( "paper3.wav", 0::second, 0::second, 1, 1, centered );
    0.5::second => now;
    PlaySndFile( "tray2.wav", 0::second, 0::second, 1, 1, centered );
    1::second => now;
    PlaySndFile( "button6.wav", 0::second, 0::second, 1, 1, centered );
    0.5::second => now;
    
    origLoopLength => loopLength;
    for( int i; i < 3; i++ )
    {
        spork ~ PlaySndFile( "printing_0.wav", i::loopLength, 0::second, 1, 1, centered );
    }
    3::loopLength => now;
    
    PlaySndFile( "printer_screech2.wav", 0::second, 0::second, 1, 1, centered );
    1::second => now;
    PlaySndFile( "paper2.wav", 0::second, 0::second, 1, 1, centered );
    
    5::second => now;
}

PlayEnd();